# Wi-Fi network scan

An action block that scans for nearby Wi-Fi networks (access points).

If the proceed option is set to Immediately, then the fiber will proceed immediately without pause with the result from the last scan. If set to When complete, then the fiber will pause until a new Wi-Fi scan has completed.

The arrays assigned to Network names, Network addresses, Network security and Signal strengths are of equal length, sorted in signal strength order. The names (SSID) array may contain `null` elements for cloaked networks.

The system may return old, cached access points when Wi-Fi is disabled.

### Throttling

- Android 8: Each background app can scan once every 30 minutes.
- Android 9: All background apps combined can scan once every 30 minutes. Each foreground app can scan four times every 2 minutes.
- Android 10+: Same limits as Android 9 unless disabled in system Developer settings.

Network security flags (bitwise) for each network:

Value | Description
--- | ---
`0x01` | WPA
`0x02` | WPA2
`0x04` | WEP

Note! Since Android 6 the system Location setting may have to be enabled. Since Android 8 throttling may apply, see above. The Configured networks option isn’t officially supported since Android 10, may not work on higher versions.

## Options

- Proceed — when the fiber should proceed.

## Input arguments

- Security — only include networks with selected security, default is to include all networks.
- Configured networks — whether to only include configured networks. (May not work on Android 10+)
- Passive — whether to passively await results without initiating a scan, ignored with proceed Immediately.

## Output variables

- Network names — variable to assign an array of network names (SSID).
- Network addresses — variable to assign an array of network addresses (BSSID).
- Network security — variable to assign an array with the security of each network.
- Signal strengths — variable to assign an array of signal strengths, in dBm.